<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">

<head>
<meta http-equiv="Content-type" content="text/html;charset=UTF-8" />
<title>Freghar's Gitlog - Remotes and remote branches</title>
</head>


<body>

<h1>Remotes and remote branches</h1>
<p>Well I see so much people being confused about remotes in git, using git-pull with the full URL again and again, saying "'master' is the official branch, don't touch it!" and other nonsenses, so I decided to write this small article.</p>
<ol>
<li>If you're looking for usage, go to <code>git-remote --help</code></li>
</ol>
<hr />
<br />

<p>When you clone a repo, you get a complete clone of all it's local branches which will become your remote branches. If the remote repository contains a "master" branch, git-clone automatically checkouts it into the working tree (so you can see the files), if not, nothing happens and you start just with .git/ directory after clone.<br />
This is really important. As you might know, Git is distributed, that means it allows you to diff, commit, pull, push, etc. even offline. The basic philosophy is that all repositories are equal to each other, there's no "main repo" and "child repos", where child can't be main repo. In real word it works that way, but "child" can do the same things as "main repo", ie. be cloned further, pull, push and other things. That's the distribution.</p>

<p>When you clone someone's repository, as said, his local branches will become your remote. That means you can checkout to them, make your local branches based on them, etc. So there's really no need to keep "master" clean, because the clean master (= the unchanged remote branch) will always be in origin/master. If you mess up something on master and want it to be re-set, just reset it to the state of origin/master:</p>
<pre>
git-reset --hard origin/master
</pre>
<p>("origin" is a name of the remote, "master" is branch in that remote)</p>
<p>As you've probably seen, there's this "origin" name. It has nothing much special compared to other remotes, it's just created automatically during the clone process and it's based on URL of the repository being cloned.</p>

<p>To show all branches (not just local ones), use <code>git-branch -a</code></p>

<p>So enought theory, let's go for some examples.</p>
<br />

<h2>Examples</h2>
<p>Let's say I have just cloned MaNGOS git repository and I want to have balrok's branches also available in my clone, so I can view/merge/make my branches based on them.<br />
It's simple:</p>
<pre>
git remote add balrok_repo git://github.com/balrok/mangos.git
</pre><br />

<p>The file .git/config now contains something more:</p>
<pre>
[remote "balrok_repo"]
        url = git://github.com/balrok/mangos.git
        fetch = +refs/heads/*:refs/remotes/balrok_repo/*
</pre>

<p>Now try <code>git-branch -a</code>  -- there aren't any new branches! In fact, git-remote just adds those 3 lines in config, no data are fetched, no packets transmitted over the network.<br />
To retrieve data, you need to fetch:</p>
<pre>
git fetch balrok_repo
</pre>
<p>This will download all his local branches and put them as remote branches in our repo. You see that now you have everything stored locally, so you don't need to connect to the remote repository when you want to take a look at some commit. git-fetch is also used the same way to perform updates of our remote branches.</p>

<p>Now you know the basics. Let's return back to the beginning - to automatically created "master" local branch. You should now know, how it was created and what's based on. Yes, from origin/master, the remote branch. So you can delete it if you don't need it. When you want to update your custom repository, just fetch (download new data to remote branches) and merge those instead of "updating" your master (merging remote branch to it) and then merging again master to your custom branch.</p>
<br />

<h2>Tracking branches</h2>
<p>There's one more thing you don't know yet -- tracking branches. You probably noticed that you can call git-pull without arguments from your local master and it updates it automatically. This is caused by one config entry, written by git-clone in .git/config:</p>
<pre>
[branch "master"]
        remote = origin
        merge = refs/heads/master
</pre>
<p>It's quite self-explaining. When you make a branch based on some branch (ie. <code>git-branch my_branch origin/otherbranch</code>), git-branch does the same as git-clone; it adds tracking to that branch (IIRC as of git v1.5.x, you had to specify <code>--track</code> before).</p>

<p>a sidenote: <u>When some branch is tracking some other, it does NOT mean that they are the same. It just allows to "git pull" without arguments, nothing more.</u></p>

<p>Well, that's all for the most of you, adding just a small paragraph about what's possible with remotes.</p>
<br />

<h2>Going lower</h2>
<p>Advanced work with remotes is based on objects. Therefore if you don't know anything about git and objects, you should go to the first chapter and read "git for computer scientists".</p>
<p>Remotes actually share the same object database as your local branch. That means you can git-log remote commits by SHA1 just as you can do with your local commits, there's no differece. You can merge them, checkout them from index, etc. It's also possible to view remote branches in history .. just <code>git-log remotename/targetbranch</code>.</p>
<p>Tags and all other objects (trees, blobs, ..) are also in your local database together with other objects.</p>
<hr />
<br />

<p>Well, so here's the end of the second chapter, hope you've enjoyed it. For further reading, please see documentation in the first chapter.</p>

<p>Freghar</p>

</body>


</html>
